﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace BTRM_WinServer
{
    class EnumDeviceHandler
    {
        [DllImport("setupapi.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr SetupDiGetClassDevs(
            ref Guid            ClassGuid,
            IntPtr              Enumerator,
            IntPtr              hwndParent,
            uint                Flags);

        [DllImport(@"setupapi.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern bool SetupDiDestroyDeviceInfoList(
            IntPtr              DeviceInfoSet);

        [DllImport("setupapi.dll")]
        public static extern bool SetupDiEnumDeviceInfo(
            IntPtr              DeviceInfoSet,
            uint                MemberIndex,
            ref SP_DEVINFO_DATA DeviceInfoData);

        [DllImport("setupapi.dll", CharSet = CharSet.Auto)]
        public static extern bool SetupDiGetDeviceRegistryProperty(
            IntPtr              DeviceInfoSet,
            ref SP_DEVINFO_DATA DeviceInfoData,
            uint                Property,
            out uint            PropertyRegDataType,
            StringBuilder       PropertyBuffer,
            uint                PropertyBufferSize,
            out uint            RequiredSize);

        [DllImport("Setupapi", CharSet = CharSet.Auto)]
        public static extern IntPtr SetupDiOpenDevRegKey(
            IntPtr              hDeviceInfoSet,
            ref SP_DEVINFO_DATA deviceInfoData,
            uint                scope,
            uint                hwProfile,
            uint                parameterRegistryValueKind,
            uint                samDesired);

        [DllImport("advapi32.dll", CharSet = CharSet.Auto)]
        public static extern int RegQueryValueEx(
            IntPtr              hKey,
            string              lpValueName,
            IntPtr              lpReserved,
            out uint            lpType,
            StringBuilder       lpData,
            ref uint            lpcbData);

        [DllImport("advapi32.dll")]
        public static extern int RegCloseKey(
            IntPtr              hKey);

        public struct SP_DEVINFO_DATA
        {
            public uint cbSize;
            public Guid ClassGuid;
            public uint DevInst;
            public IntPtr Reserved;
        }

        public const uint DIGCF_DEFAULT         = 0x00000001;
        public const uint DIGCF_PRESENT         = 0x00000002;
        public const uint DIGCF_ALLCLASSES      = 0x00000004;
        public const uint DIGCF_PROFILE         = 0x00000008;
        public const uint DIGCF_DEVICEINTERFACE = 0x00000010;

        public const uint SPDRP_DEVICEDESC                  = 0x00000000;
        public const uint SPDRP_HARDWAREID                  = 0x00000001;
        public const uint SPDRP_COMPATIBLEIDS               = 0x00000002;
        public const uint SPDRP_NTDEVICEPATHS               = 0x00000003;
        public const uint SPDRP_SERVICE                     = 0x00000004;
        public const uint SPDRP_CONFIGURATION               = 0x00000005;
        public const uint SPDRP_CONFIGURATIONVECTOR         = 0x00000006;
        public const uint SPDRP_CLASS                       = 0x00000007;
        public const uint SPDRP_CLASSGUID                   = 0x00000008;
        public const uint SPDRP_DRIVER                      = 0x00000009;
        public const uint SPDRP_CONFIGFLAGS                 = 0x0000000A;
        public const uint SPDRP_MFG                         = 0x0000000B;
        public const uint SPDRP_FRIENDLYNAME                = 0x0000000C;
        public const uint SPDRP_LOCATION_INFORMATION        = 0x0000000D;
        public const uint SPDRP_PHYSICAL_DEVICE_OBJECT_NAME = 0x0000000E;
        public const uint SPDRP_CAPABILITIES                = 0x0000000F;
        public const uint SPDRP_UI_NUMBER                   = 0x00000010;
        public const uint SPDRP_UPPERFILTERS                = 0x00000011;
        public const uint SPDRP_LOWERFILTERS                = 0x00000012;
        public const uint SPDRP_MAXIMUM_PROPERTY            = 0x00000013;

        public const uint DICS_FLAG_GLOBAL          = 0x00000001;
        public const uint DICS_FLAG_CONFIGSPECIFIC  = 0x00000002;

        public const uint DIREG_DEV     = 0x00000001;
        public const uint DIREG_DRV     = 0x00000002;
        public const uint DIREG_BOTH    = 0x00000004;

        public const uint KEY_QUERY_VALUE           = 0x0001;
        public const uint KEY_SET_VALUE             = 0x0002;
        public const uint KEY_CREATE_SUB_KEY        = 0x0004;
        public const uint KEY_ENUMERATE_SUB_KEYS    = 0x0008;
    }
}
