﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Management;
using System.Diagnostics;
using System.IO.Ports;
using System.IO;
using System.Drawing.Imaging;
using System.Threading; 
using System.Reflection;

namespace BTRM_WinServer
{
    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll")]
        public static extern bool AllocConsole();

        private SendInputHandler.INPUT[] leftDown;
        private SendInputHandler.INPUT[] leftUp;
        private SendInputHandler.INPUT[] moveLeft;
        private SendInputHandler.INPUT[] moveRight;
        private SendInputHandler.INPUT[] moveUp;
        private SendInputHandler.INPUT[] moveDown;

        private System.Threading.Timer moveLeftTimer;
        private System.Threading.Timer moveRightTimer;
        private System.Threading.Timer moveDownTimer;
        private System.Threading.Timer moveUpTimer;

        private Thread thread;

        public Form1()
        {
            InitializeComponent();

            // 列挙には時間がかかるので、透明度100％＆タスクトレイ非表示で開始する

            // 透明度を100％にする
            this.Opacity = 0;
            // タスクトレイにアイコンを表示しない
            notifyIcon1.Visible = false;

            // コンソールを開く
//            AllocConsole();

            leftDown = new SendInputHandler.INPUT[1];
            leftDown[0].type = SendInputHandler.INPUT_MOUSE;
            leftDown[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_LEFTDOWN;
            leftUp = new SendInputHandler.INPUT[1];
            leftUp[0].type = SendInputHandler.INPUT_MOUSE;
            leftUp[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_LEFTUP;
            moveLeft = new SendInputHandler.INPUT[1];
            moveLeft[0].type = SendInputHandler.INPUT_MOUSE;
            moveLeft[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_MOVED;
            moveLeft[0].mi.dx = -1;
            moveLeft[0].mi.dy = 0;
            moveRight = new SendInputHandler.INPUT[1];
            moveRight[0].type = SendInputHandler.INPUT_MOUSE;
            moveRight[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_MOVED;
            moveRight[0].mi.dx = 1;
            moveRight[0].mi.dy = 0;
            moveUp = new SendInputHandler.INPUT[1];
            moveUp[0].type = SendInputHandler.INPUT_MOUSE;
            moveUp[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_MOVED;
            moveUp[0].mi.dx = 0;
            moveUp[0].mi.dy = -1;
            moveDown = new SendInputHandler.INPUT[1];
            moveDown[0].type = SendInputHandler.INPUT_MOUSE;
            moveDown[0].mi.dwFlags = SendInputHandler.MOUSEEVENTF_MOVED;
            moveDown[0].mi.dx = 0;
            moveDown[0].mi.dy = 1;
            TimerCallback cb = new TimerCallback(timer_Timeout);
            moveUpTimer = new System.Threading.Timer(cb, moveUp, 0, Timeout.Infinite);
            moveDownTimer = new System.Threading.Timer(cb, moveDown, 0, Timeout.Infinite);
            moveLeftTimer = new System.Threading.Timer(cb, moveLeft, 0, Timeout.Infinite);
            moveRightTimer = new System.Threading.Timer(cb, moveRight, 0, Timeout.Infinite);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            updateMenu(enumComPort());
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            // ウインドウを非表示にする
            this.Hide();
            // 透明度を0％に戻す
            this.Opacity = 1;
            // タスクトレイにアイコン表示
            notifyIcon1.Visible = true;

            // ポートが開かれていない場合は、バルーン表示
            if (serialPort1.IsOpen == false)
            {
                notifyIcon1.ShowBalloonTip(3000,"おしらせ", "COMポートを選択してください", ToolTipIcon.Warning);
            }
        }

        private void toolStripMenuItem_Click(object sender, EventArgs e)
        {
            // チェックマークを更新
            ToolStripMenuItem item = (ToolStripMenuItem)sender;
            foreach (ToolStripMenuItem i in item.GetCurrentParent().Items)
            {
                i.Checked = false;
                IniFileHandler.WritePrivateProfileString("BTRM_WinServer", i.Text, "false", ".\\BTRM_WinServer.ini");
            }
            item.Checked = true;
            IniFileHandler.WritePrivateProfileString("BTRM_WinServer", item.Text, "true", ".\\BTRM_WinServer.ini");

            // COMポートを開く
            string caption = item.Text;
            int end = caption.IndexOf(' ');
            try
            {
                serialPort1.Close();
            }
            catch (Exception ex)
            {
            }
            serialPort1.PortName = caption.Substring(0, end);
            serialPort1.NewLine = "\r\n";
            serialPort1.Open();
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            SerialPort port = (SerialPort)sender;
            try
            {
                // タイムアウトの例外発生まで繰り返し
                while (true)
                {
                    string s = port.ReadLine();
                    if (s.IndexOf("SIZE") == 0)
                    {
                        int screenWidth = Screen.PrimaryScreen.Bounds.Width;
                        int screenHeight = Screen.PrimaryScreen.Bounds.Height;
                        serialPort1.WriteLine(screenWidth + " " + screenHeight);
                    }
                    else if (s.IndexOf("GET") == 0)
                    {
                        int size = int.Parse( s.Substring( s.IndexOf("GET")+"GET".Length+1) );

                        thread = new Thread(new ParameterizedThreadStart(this.sendImage));
                        thread.Start(size);
                    }
                    else if (s.IndexOf("PRESS") == 0)
                    {
                        if (s.IndexOf("SELECT") == "PRESS ".Length)
                        {
                            SendInputHandler.SendInput(1, leftDown, Marshal.SizeOf(leftDown[0]));
                        }
                        else if (s.IndexOf("UP") == "PRESS ".Length)
                        {
                            moveUp[0].mi.dx = 0;
                            moveUp[0].mi.dy = -1;
                            moveUpTimer.Change(0, 100);
                        }
                        else if (s.IndexOf("DOWN") == "PRESS ".Length)
                        {
                            moveDown[0].mi.dx = 0;
                            moveDown[0].mi.dy = 1;
                            moveDownTimer.Change(0, 100);
                        }
                        else if (s.IndexOf("LEFT") == "PRESS ".Length)
                        {
                            moveLeft[0].mi.dx = -1;
                            moveLeft[0].mi.dy = 0;
                            moveLeftTimer.Change(0, 100);
                        }
                        else if (s.IndexOf("RIGHT") == "PRESS ".Length)
                        {
                            moveRight[0].mi.dx = 1;
                            moveRight[0].mi.dy = 0;
                            moveRightTimer.Change(0, 100);
                        }
                    }
                    else if (s.IndexOf("RELEASE") == 0)
                    {
                        if (s.IndexOf("SELECT") == "RELEASE ".Length)
                        {
                            SendInputHandler.SendInput(1, leftUp, Marshal.SizeOf(leftUp[0]));
                        }
                        else if (s.IndexOf("UP") == "RELEASE ".Length)
                        {
                            moveUpTimer.Change(0, Timeout.Infinite);
                        }
                        else if (s.IndexOf("DOWN") == "RELEASE ".Length)
                        {
                            moveDownTimer.Change(0, Timeout.Infinite);
                        }
                        else if (s.IndexOf("LEFT") == "RELEASE ".Length)
                        {
                            moveLeftTimer.Change(0, Timeout.Infinite);
                        }
                        else if (s.IndexOf("RIGHT") == "RELEASE ".Length)
                        {
                            moveRightTimer.Change(0, Timeout.Infinite);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
            }
        }

        private void sendImage(object data)
        {
            try {
                int size = (int)data;

                int screenWidth = Screen.PrimaryScreen.Bounds.Width;
                int screenHeight = Screen.PrimaryScreen.Bounds.Height;

                int width = size;
                int height = size * screenHeight / screenWidth;

                //画面全体をコピーする
                Bitmap screenBitmap = new Bitmap(screenWidth, screenHeight);
                Graphics screenGraphics = Graphics.FromImage(screenBitmap);
                screenGraphics.CopyFromScreen(new Point(0, 0), new Point(0, 0), screenBitmap.Size);
                screenGraphics.Dispose();

                //縮小する
                Bitmap bmp = new Bitmap(width, height);
                Graphics g = Graphics.FromImage(bmp);
                g.DrawImage(screenBitmap, 0, 0, width, height);
                g.Dispose();

                //出力する
                MemoryStream stream = new MemoryStream();
                bmp.Save(stream, ImageFormat.Jpeg);
                byte[] img = stream.GetBuffer();
                int len = (int)stream.Length;
                stream.Close();
                serialPort1.WriteLine(""+len);
                serialPort1.Write(img, 0, len);
            }
            catch (Exception ex)
            {
            }
        }

        private void timer_Timeout(object o)
        {
            SendInputHandler.INPUT[] input = (SendInputHandler.INPUT[])o;
            if (input[0].mi.dx > 0) input[0].mi.dx++;
            if (input[0].mi.dx < 0) input[0].mi.dx--;
            if (input[0].mi.dy > 0) input[0].mi.dy++;
            if (input[0].mi.dy < 0) input[0].mi.dy--;
            SendInputHandler.SendInput(1, input, Marshal.SizeOf(input[0]));
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            this.Show();
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            // タスクトレイにアイコンを消去
            notifyIcon1.Visible = false;

            // 送信中の場合、強制終了
            try
            {
                thread.Abort();
            }
            catch (Exception ex)
            {
            }
            Application.Exit();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Application.Exit()以外では、終了しない
            if (e.CloseReason != CloseReason.ApplicationExitCall)
            {
                this.Hide();
                e.Cancel = true;
            }
        }

        private void notifyIcon1_MouseUp(object sender, MouseEventArgs e)
        {
            // 左クリックでタスクトレイのメニューを表示する
            if (e.Button == MouseButtons.Left)
            {
                MethodInfo mi = typeof(NotifyIcon).GetMethod("ShowContextMenu", BindingFlags.Instance | BindingFlags.NonPublic);
                mi.Invoke(this.notifyIcon1, null);
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            // ブラウザ起動
            LinkLabel linkLabel = (LinkLabel)sender;
            System.Diagnostics.Process.Start(linkLabel.Text);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            BeginInvoke((MethodInvoker)delegate()
            {
                updateMenu(enumComPort());
            });
        }

        private List<string> enumComPort()
        {
            List<string> result = new List<string>();

            bool ret;

            // COMポートのデバイス情報を取得
            Guid guid = new Guid("86E0D1E0-8089-11D0-9CE4-08003E301F73");
            EnumDeviceHandler.SP_DEVINFO_DATA DeviceInfoData = new EnumDeviceHandler.SP_DEVINFO_DATA();
            DeviceInfoData.cbSize = (uint)Marshal.SizeOf(DeviceInfoData);
            IntPtr hDeviceInfoSet = EnumDeviceHandler.SetupDiGetClassDevs(ref guid, IntPtr.Zero, IntPtr.Zero, (EnumDeviceHandler.DIGCF_PRESENT | EnumDeviceHandler.DIGCF_DEVICEINTERFACE));

            // 列挙の終わりまでループ
            for (uint i = 0; ; i++)
            {
                // デバイスを列挙
                ret = EnumDeviceHandler.SetupDiEnumDeviceInfo(hDeviceInfoSet, i, ref DeviceInfoData);
                if (ret == false) break;

                // デバイス名を取得
                uint PropertyRegDataType;
                StringBuilder PropertyBuffer = new StringBuilder(256);
                uint RequiredSize;
                ret = EnumDeviceHandler.SetupDiGetDeviceRegistryProperty(hDeviceInfoSet, ref DeviceInfoData, EnumDeviceHandler.SPDRP_DEVICEDESC, out PropertyRegDataType, PropertyBuffer, (uint)PropertyBuffer.Capacity, out RequiredSize);
                if (ret == false) continue;

                // COMポート番号を取得
                IntPtr hRegKey = EnumDeviceHandler.SetupDiOpenDevRegKey(hDeviceInfoSet, ref DeviceInfoData, EnumDeviceHandler.DICS_FLAG_GLOBAL, (uint)0, EnumDeviceHandler.DIREG_DEV, EnumDeviceHandler.KEY_QUERY_VALUE);
                uint type;
                StringBuilder Data = new StringBuilder(256);
                uint size = (uint)Data.Capacity;
                EnumDeviceHandler.RegQueryValueEx(hRegKey, "PortName", IntPtr.Zero, out type, Data, ref size);
                EnumDeviceHandler.RegCloseKey(hRegKey);

                // 戻り値に追加
                result.Add( Data.ToString() + " : " + PropertyBuffer.ToString() );
            }
            EnumDeviceHandler.SetupDiDestroyDeviceInfoList(hDeviceInfoSet);

            return result;
        }

        private void updateMenu(List<string> list)
        {
            bool add = false;
            bool open = false;
            bool remove = false;
            bool close = false;

            // 項目の削除
            int index = 0;
            while( index < toolStripMenuItem1.DropDownItems.Count )
            {
                ToolStripMenuItem item = (ToolStripMenuItem)toolStripMenuItem1.DropDownItems[index];
                if (false == list.Contains(item.Name))
                {
                    // Open中の場合、クローズ
                    if (item.Checked)
                    {
                        try
                        {
                            serialPort1.Close();
                        }
                        catch (Exception ex)
                        {
                        }
                        close = true;
                    }
                    toolStripMenuItem1.DropDownItems.Remove(item);
                    remove = true;
                    index = 0;
                }
                else
                {
                    index++;
                }
            }
            // 項目の追加
            foreach (string text in list)
            {
                if (false == toolStripMenuItem1.DropDownItems.ContainsKey(text))
                {
                    ToolStripMenuItem item = new ToolStripMenuItem(text, null, toolStripMenuItem_Click);
                    item.Name = text;

                    // 設定値を参照して、オープン
                    StringBuilder sb = new StringBuilder(256);
                    IniFileHandler.GetPrivateProfileString("BTRM_WinServer", text, "false", sb, (uint)sb.Capacity, ".\\BTRM_WinServer.ini");
                    if (sb.ToString().CompareTo("false") == 0)
                    {
                        item.Checked = false;
                    }
                    else
                    {
                        item.Checked = true;

                        string caption = item.Text;
                        int end = caption.IndexOf(' ');
                        serialPort1.PortName = caption.Substring(0, end);
                        serialPort1.NewLine = "\r\n";
                        serialPort1.Open();
                        open = true;
                    }
                    toolStripMenuItem1.DropDownItems.Add(item);
                    add = true;
                }
            }

            // バルーン表示
            if (close == true)
            {
                notifyIcon1.ShowBalloonTip(3000, "おしらせ", "COMポートを閉じました", ToolTipIcon.Warning);
            }
            else if (open == true)
            {
                notifyIcon1.ShowBalloonTip(3000, "おしらせ", "COMポートを開きました", ToolTipIcon.Warning);
            }
            else if (add == true || remove == true)
            {
                notifyIcon1.ShowBalloonTip(3000, "おしらせ", "COMポートが更新されました", ToolTipIcon.Warning);
            }
        }
    }
}
